;---------------------------
;--==ImageGrabber==--
;v1.4
;+DragDrop added
;+Screen_Offset added
;+2<->4bit bug fixed

;v1.5
;+Zoom
;
;v1.6
;+32bit added
;+RGB -> GBR changed in 24b and 32b
;
;
;v1.7
;Color Mask Added
; 
;---------------------------

.686
.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive

include viewer.inc

.code

start:
	call	generate_gradient
	invoke	GetModuleHandle,NULL
	mov		hInstance,eax
	mov		icex.dwSize,sizeof INITCOMMONCONTROLSEX
	mov		icex.dwICC,0FFFFh
	invoke	InitCommonControlsEx,ADDR icex
	
	invoke	DialogBoxParam,hInstance,IDD_DIALOG1,NULL,addr DlgProc,NULL
	invoke	ExitProcess,0

;########################################################################

DlgProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL	buffer[256]:byte
	LOCAL	buffer2[256]:byte
;	LOCAL	hImStat:dword
	LOCAL	hCombo:dword
	
	mov		ecx,hWin
	mov		eax,uMsg
	.if eax==WM_INITDIALOG
		invoke	InitMaskTable, hWin
		
;		invoke	GetDlgItem,hWin,IDC_MASK_BMP
;		mov		hImStat, eax
;		invoke	LoadImage,hInstance,3002,IMAGE_BITMAP,0,0,NULL
;		invoke	SendMessage,hImStat,STM_SETIMAGE,IMAGE_BITMAP,eax
		
		invoke	GetDlgItem, hWin, IDC_ZOOM
		mov		hCombo, eax
		invoke	SendMessage, hCombo, CB_ADDSTRING, 0,offset sz_1
		invoke	SendMessage, hCombo, CB_ADDSTRING, 0,offset sz_2
		invoke	SendMessage, hCombo, CB_ADDSTRING, 0,offset sz_4
		invoke	SendMessage, hCombo, CB_ADDSTRING, 0,offset sz_8
		invoke	SendMessage, hCombo, CB_ADDSTRING, 0,offset sz_16
		invoke	SendMessage, hCombo, CB_ADDSTRING, 0,offset sz_025
		invoke	SendMessage, hCombo, CB_ADDSTRING, 0,offset sz_05
		invoke	SendMessage, hCombo, CB_SETCURSEL, 0 , 0
	
		;Default values
		mov		im_width, DEF_WIDTH
		mov		im_height,DEF_HEIGHT
		mov		im_offset, 0
		mov		im_bpp, 8

		;Set Status Bar Text
		invoke	SetDlgItemText,hWin,IDC_SBR1,offset sz_hint1

		mov	ifn.lStructSize,SIZEOF ifn
		mov	eax,hInstance
		mov	ifn.hInstance,eax
		mov	ifn.lpstrFilter, OFFSET FilterString
		mov	ifn.lpstrFile, 	 OFFSET szLibFile
		mov	ifn.nMaxFile,MAXSIZE
		mov	ecx, hWin
		mov	ifn.hWndOwner,ecx

		mov	ofn.lStructSize,SIZEOF ofn
		mov	eax,hInstance
		mov	ofn.hInstance,eax
		mov	ofn.lpstrFilter, OFFSET FilterString2
		mov	ofn.lpstrFile, 	 OFFSET szSaveFile
		mov	ofn.nMaxFile,MAXSIZE
		mov	ecx, hWin
		mov	ofn.hWndOwner,ecx


		;BPP
		invoke	CheckRadioButton,hWin,IDC_RBN1,IDC_RBN7,IDC_RBN4
		
		invoke LoadIcon,hInstance,ID_ICON
		invoke PostMessage, hWin, WM_SETICON, ICON_BIG, eax
		
		;Width
		invoke SendDlgItemMessage,hWin,IDC_UDN1,UDM_SETRANGE32,0,2048
		invoke SendDlgItemMessage,hWin,IDC_UDN1,UDM_SETPOS32,0,im_width
		;Height
		invoke SendDlgItemMessage,hWin,IDC_UDN2,UDM_SETRANGE32,0,2048
		invoke SendDlgItemMessage,hWin,IDC_UDN2,UDM_SETPOS32,0,im_height
		;Offset
		invoke SendDlgItemMessage,hWin,IDC_UDN3,UDM_SETRANGE32,0,4*1024*1024
		invoke SendDlgItemMessage,hWin,IDC_UDN3,UDM_SETPOS32,0,im_offset
		
		;Register Class
		mov		wc.cbSize,sizeof WNDCLASSEX
		mov		wc.style, 0
		mov		wc.lpfnWndProc, offset WndProc
		mov		wc.cbClsExtra,NULL
		mov		wc.cbWndExtra,NULL
		push	hInstance
		pop		wc.hInstance
		mov		wc.hbrBackground,COLOR_BTNFACE+1
		mov		wc.lpszClassName,offset ClassName
		invoke	RegisterClassEx, addr wc
		invoke	CreateWindowEx,0,addr ClassName,addr AppName, WS_POPUP + WS_VISIBLE,0,0,DEF_WIDTH,DEF_HEIGHT,0,0,hInstance,0

		mov		hView,eax
		invoke	ShowWindow, hView,SW_SHOWNORMAL

		invoke	GetDlgItem, hWin, IDC_BTN1
		invoke	SetFocus, eax
		xor		eax, eax
		ret
	.elseif eax==WM_COMMAND
		.if	wParam == IDC_BTN1
			mov	ifn.Flags, OFN_FILEMUSTEXIST or OFN_PATHMUSTEXIST or OFN_LONGNAMES or OFN_EXPLORER or OFN_HIDEREADONLY
			invoke	GetOpenFileName, ADDR ifn
			invoke	SetDlgItemText,hWin,IDC_EDT5,ifn.lpstrFile			
			invoke	GetDlgItemText,hWin,IDC_EDT5,addr buffer, 256
			mov		al, [buffer]
			.if(al!=0)
				invoke	loadFile, ifn.lpstrFile
				.if	eax!=0
					mov	byte ptr [buffer],0
					invoke	szCatStr,addr buffer, offset sz_hint2
					invoke	dw2a, f_size,addr buffer2
					invoke	szCatStr,addr buffer, addr buffer2
					;file loaded
					invoke	SetDlgItemText,hWin,IDC_SBR1,addr buffer
					mov		fFileLoaded, 1
					;Enable 'Grab' button
					invoke	GetDlgItem,hWin,IDC_BTN3
					invoke	EnableWindow,eax,1
					
					invoke	ViewHandler, hWin
				.else
					;error
					invoke	MessageBox,hWin,offset sz_er1,0,MB_ICONERROR or MB_TOPMOST
				.endif
			.endif
		.elseif wParam==IDC_BTN2		;Apply Button
			invoke	ViewHandler, hWin
		.elseif wParam==IDC_BTN3
			invoke	GrabImage, hWin, ofn.lpstrFile
		.elseif wParam==IDC_BTN4		;About Button
			invoke	MessageBox,hWin,addr sz_about,addr sz_prog,MB_ICONASTERISK or MB_TOPMOST
		.elseif wParam==IDC_BTN5		;+Step Offset
			;db 0cch
			invoke	getStep, hWin
			push	eax
			invoke	GetDlgItemInt,hWin,IDC_EDT3,addr is_good,0
			pop		edx
			add		eax, edx
			invoke	SetDlgItemInt,hWin,IDC_EDT3,eax,0
			invoke	ViewHandler, hWin

		.elseif wParam==IDC_BTN6
			invoke	getStep, hWin
			push	eax
			invoke	GetDlgItemInt,hWin,IDC_EDT3,addr is_good,0
			pop		edx
			sub		eax, edx

			js		@not_set
			invoke	SetDlgItemInt,hWin,IDC_EDT3,eax,0
			invoke	ViewHandler, hWin
@not_set:
		.endif
	.elseif eax==WM_CLOSE
		invoke EndDialog,hWin,0
	.elseif eax==WM_VSCROLL
		invoke	ViewHandler, hWin
		
	.elseif uMsg==WM_DROPFILES
			;input file name
			invoke	DragQueryFile, wParam, 0, ifn.lpstrFile, MAX_PATH-1
			invoke	SetDlgItemText, hWin, IDC_EDT5, ifn.lpstrFile
			invoke	loadFile, ifn.lpstrFile
			.if	eax!=0
				mov	byte ptr [buffer],0
				invoke	szCatStr,addr buffer, offset sz_hint2
				invoke	dw2a, f_size,addr buffer2
				invoke	szCatStr,addr buffer, addr buffer2
				;file loaded
				invoke	SetDlgItemText,hWin,IDC_SBR1,addr buffer
				mov		fFileLoaded, 1
				;Enable 'Grab' button
				invoke	GetDlgItem,hWin,IDC_BTN3
				invoke	EnableWindow,eax,1
					
				invoke	ViewHandler, hWin
			.endif		
	.else
		mov		eax,FALSE
		ret
	.endif
	mov		eax,TRUE
	ret

DlgProc endp

WndProc proc hWin:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

    LOCAL var    :DWORD
    LOCAL caW    :DWORD
    LOCAL caH    :DWORD
    LOCAL Rct    :RECT
    LOCAL hDC    :DWORD
    LOCAL Ps     :PAINTSTRUCT
    LOCAL buffer1[128]:BYTE  ; these are two spare buffers
    LOCAL buffer2[128]:BYTE  ; for text manipulation etc..

    .if uMsg == WM_COMMAND
    ;======== menu commands ========
    .elseif uMsg == WM_CREATE
    .elseif uMsg == WM_SIZE
    .elseif uMsg == WM_PAINT
        invoke BeginPaint,hWin,ADDR Ps
          mov hDC, eax
          invoke Paint_Proc,hWin,hDC
        invoke EndPaint,hWin,ADDR Ps
        xor		eax, eax
        ret
    .elseif uMsg == WM_CLOSE

    .elseif uMsg == WM_DESTROY
        invoke PostQuitMessage,NULL
        xor		eax,eax
        ret
    .endif
    
	invoke DefWindowProc,hWin,uMsg,wParam,lParam
	ret
WndProc endp

loadFile	proc	path:dword
	LOCAL	hfile:dword
	LOCAL	temp:dword
	
	.if((f_size!=0)&&(f_data!=0))
		invoke VirtualFree, f_data,0,MEM_RELEASE
	.endif
	
	invoke	CreateFile,path,GENERIC_READ,FILE_SHARE_READ,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0
	cmp		eax, -1
	jz		@F
	mov		hfile, eax
	invoke	GetFileSize,hfile,0
	mov		f_size, eax
	invoke	VirtualAlloc,0,f_size,MEM_COMMIT + MEM_RESERVE,PAGE_READWRITE
	mov		f_data, eax
	invoke	ReadFile,hfile,f_data,f_size,addr temp, 0
	invoke	CloseHandle,hfile
	xor		eax, eax
	inc		eax
	ret
@@:
	xor		eax, eax
	ret
loadFile endp

dw2a proc dwValue:DWORD, lpBuffer:DWORD
; #########################################################################
    ; -------------------------------------------------------------
    ; convert DWORD to ascii string
    ; dwValue is value to be converted
    ; lpBuffer is the address of the receiving buffer
    ; EXAMPLE:
    ; invoke dwtoa,edx,ADDR buffer
    ;
    ; Uses: eax, ecx, edx.
    ; -------------------------------------------------------------
    push ebx
    push esi
    push edi
    mov eax, dwValue
    mov edi, [lpBuffer]
    or eax,eax
    jnz sign
  zero:
    mov word ptr [edi],30h
    jmp dw2asc
  sign:
    jns pos
    mov byte ptr [edi],'-'
    neg eax
    inc edi
  pos:      
    mov ecx,429496730
    mov esi, edi
    .while (eax > 0)
      mov ebx,eax
      mul ecx
      mov eax,edx
      lea edx,[edx*4+edx]
      add edx,edx
      sub ebx,edx
      add bl,'0'
      mov [edi],bl
      inc edi
    .endw
    mov byte ptr [edi], 0       ; terminate the string
    ; We now have all the digits, but in reverse order.
    .while (esi < edi)
      dec edi
      mov al, [esi]
      mov ah, [edi]
      mov [edi], al
      mov [esi], ah
      inc esi
    .endw
    dw2asc:
    pop edi
    pop esi
    pop ebx
    ret
dw2a endp


szStrLen proc item:DWORD
    push    ebx
    mov     eax,item               ; get pointer to string
    lea     edx,[eax+3]            ; pointer+3 used in the end
  @@:     
    mov     ebx,[eax]              ; read first 4 bytes
    add     eax,4                  ; increment pointer
    lea     ecx,[ebx-01010101h]    ; subtract 1 from each byte
    not     ebx                    ; invert all bytes
    and     ecx,ebx                ; and these two
    and     ecx,80808080h    
    jz      @B                     ; no zero bytes, continue loop
    test    ecx,00008080h          ; test first two bytes
    jnz     @F
    shr     ecx,16                 ; not in the first 2 bytes
    add     eax,2
  @@:
    shl     cl,1                   ; use carry flag to avoid branch
    sbb     eax,edx                ; compute length
    pop     ebx
    ret
szStrLen endp

szCatStr proc lpszSource:DWORD, lpszAdd:DWORD
    invoke szStrLen,lpszSource
    mov edx, lpszSource
    mov ecx, lpszAdd
    add edx, eax

  @@:
    mov al, [ecx]
    mov [edx], al
    inc ecx
    inc edx
    test al, al       ; test for zero
    jne @B
    ret
szCatStr endp

ViewHandler	proc	hw:dword
	LOCAL	tim_width:dword
	LOCAL	tim_height:dword
	LOCAL	tim_zoom:dword
	LOCAL	hCombo:dword
	
	invoke	GetMaskParams, hw
	
	;---------------------------------
	invoke	IsDlgButtonChecked,hw,IDC_CHK2
	.if		eax == BST_CHECKED
		mov	dword ptr fInvertHoriz, 1
	.else
		mov	dword ptr fInvertHoriz, 0
	.endif

	invoke	IsDlgButtonChecked,hw,IDC_CHK3
	.if		eax == BST_CHECKED
		mov	dword ptr fInvertVert, 1
	.else
		mov	dword ptr fInvertVert, 0
	.endif
	
	invoke	IsDlgButtonChecked,hw,IDC_CHK1
	.if		eax == BST_CHECKED
		mov	dword ptr fConvert24, 1
	.else
		mov	dword ptr fConvert24, 0
	.endif

	;-----------------------------------
	
	invoke	GetDlgItemInt,hw,IDC_EDT1,addr is_good,FALSE
	mov		ecx, is_good
	.if	ecx==0
		invoke	MessageBox,hw,offset sz_er2,0,MB_ICONERROR or MB_TOPMOST
		ret
	.endif
	mov		im_width, eax
	
	invoke	GetDlgItemInt,hw,IDC_EDT2,addr is_good,FALSE
	mov		ecx, is_good
	.if	ecx==0
		invoke	MessageBox,hw,offset sz_er2,0,MB_ICONERROR or MB_TOPMOST
		ret
	.endif
	mov		im_height, eax

	invoke	GetDlgItemInt,hw,IDC_EDT3,addr is_good,FALSE
	mov		ecx, is_good
	.if	ecx==0
		invoke	MessageBox,hw,offset sz_er2,0,MB_ICONERROR or MB_TOPMOST
		ret
	.endif
	mov		im_offset, eax

;------------------------------

.if(fFileLoaded!=0)
	invoke	getBPP, hw
	mov		bpp, eax	
	invoke	calc_pref_size, bpp
	
	.if(eax <= f_size)
		mov		fSizeIn, 1
		invoke	SetDlgItemText,hw,IDC_SBR1,addr sz_hint3
	.else
		mov		fSizeIn, 0
		invoke	SetDlgItemText,hw,IDC_SBR1,addr sz_hint4
	.endif
.endif
;------------------------------
;	invoke	GetDlgItemInt,hw,IDC_EDT4,addr is_good,FALSE
	
	;Get user selected texture format
	invoke GetDlgItem, hw, IDC_ZOOM
	mov		hCombo, eax
	invoke  SendMessage, hCombo , CB_GETCURSEL , 0 , 0
	.if((eax==0)||(eax==1)||(eax==2)||(eax==3)||(eax==4))
		;x1, x2, x4, x8, x16
		mov		ecx, eax
		mov		eax, 1
		shl		eax, cl	;1<<idx
		
		mov		tim_zoom, eax
		mov		im_zoom, eax	;Save Zoom-value for next use
	
		mov		eax, tim_zoom
		mov		edx, im_width
		mul		edx
		mov		tim_width, eax

		mov		eax, tim_zoom
		mov		edx, im_height
		mul		edx
		mov		tim_height, eax
	.elseif(eax==6)
		;x0.5
		mov		im_zoom, 128	;0.5
		mov		eax, im_width
		shr		eax, 1
		mov		tim_width, eax
		
		mov		eax, im_height
		shr		eax, 1
		mov		tim_height, eax
	.elseif(eax==5)
		;0.25
		mov		im_zoom, 129	;0.25
		mov		eax, im_width
		shr		eax, 2
		mov		tim_width, eax
		
		mov		eax, im_height
		shr		eax, 2
		mov		tim_height, eax
	.endif
	
	;Change Window Size
	invoke	SetWindowPos,hView,HWND_TOP,0,0,tim_width,tim_height,SWP_SHOWWINDOW+ SWP_NOMOVE
	.if		eax==0
		invoke	MessageBox,hw,offset sz_er3,0,MB_ICONERROR or MB_TOPMOST
		ret
	.endif
	;Update window view
	invoke	InvalidateRect,hView, 0,0
	ret
ViewHandler endp

Paint_Proc proc uses esi hWin:DWORD, hDC:DWORD
    LOCAL	hOld:DWORD
    LOCAL	memDC:DWORD
    LOCAL	hBMP:dword

	LOCAL	tim_width:dword
	LOCAL	tim_height:dword
	LOCAL	tim_zoom:dword
   
	mov		esi, f_data
	mov		eax, im_offset
	add		esi, eax			;Pointer to data
	mov		pData, esi
	
	.if((fFileLoaded!=0)&&(fSizeIn!=0))

		invoke	CreateCompatibleDC,hDC
		mov		memDC, eax
		invoke	CreateCompatibleBitmap,hDC,im_width,im_height
		mov		hBMP, eax
		invoke	SelectObject,memDC,hBMP
		mov		hOld, eax
		
		.if(bpp==8)
			invoke	draw_8,memDC
		.elseif(bpp==24)
			invoke	draw_24,memDC
		.elseif(bpp==16)
			invoke	draw_16,memDC
		.elseif(bpp==1)
			invoke	draw_1,memDC
		.elseif(bpp==2)
			invoke	draw_2,memDC
		.elseif(bpp==4)
			invoke	draw_4,memDC
		.elseif(bpp==32)
			invoke	draw_32, memDC
		.endif

		mov		eax, im_zoom
		.if(eax==128)
			mov		eax, im_width
			shr		eax, 1
			mov		tim_width, eax
		
			mov		eax, im_height
			shr		eax, 1
			mov		tim_height, eax	
		.elseif(eax==129)
			mov		eax, im_width
			shr		eax, 2
			mov		tim_width, eax
		
			mov		eax, im_height
			shr		eax, 2
			mov		tim_height, eax	
		.else
			mov		edx, im_width
			mul		edx
			mov		tim_width, eax

			mov		eax, im_zoom
			mov		edx, im_height
			mul		edx
			mov		tim_height, eax
		.endif
		
		;invoke	BitBlt,hDC,0,0,im_width,im_height,memDC,0,0,SRCCOPY
		invoke	SetStretchBltMode, hDC, HALFTONE
		invoke	StretchBlt,hDC,0,0,tim_width,tim_height,memDC,0,0,im_width,im_height,SRCCOPY
		
		invoke	DeleteObject, hBMP
	    invoke	DeleteDC,memDC
	.endif
	xor		eax, eax
    ret
Paint_Proc endp

getBPP	proc	hWnd:dword
	invoke IsDlgButtonChecked, hWnd, IDC_RBN1
	.if eax == BST_CHECKED
		mov		eax, 1
		ret
	.endif

	invoke IsDlgButtonChecked, hWnd, IDC_RBN2
	.if eax == BST_CHECKED
		mov		eax, 2
		ret
	.endif

	invoke IsDlgButtonChecked, hWnd, IDC_RBN3
	.if eax == BST_CHECKED
		mov		eax, 4
		ret
	.endif
	
	invoke IsDlgButtonChecked, hWnd, IDC_RBN4
	.if eax == BST_CHECKED
		mov		eax, 8
		ret
	.endif

	invoke IsDlgButtonChecked, hWnd, IDC_RBN5
	.if eax == BST_CHECKED
		mov		eax, 16
		ret
	.endif

	invoke IsDlgButtonChecked, hWnd, IDC_RBN6
	.if eax == BST_CHECKED
		mov		eax, 24
		ret
	.endif

	invoke IsDlgButtonChecked, hWnd, IDC_RBN7
	.if eax == BST_CHECKED
		mov		eax, 32
		ret
	.endif

	ret
getBPP endp

calc_pref_size	proc bpp_:dword
	mov		ecx, im_width
	mov		eax, im_height
	mul		ecx				;x*y
	mov		edx, im_offset
	.if(bpp_==1)
		shr		eax, 3
		add		eax, edx
		ret
	.elseif(bpp_==2)
		shr		eax, 2
		add		eax, edx
		ret
	.elseif(bpp_==4)
		shr		eax, 1
		add		eax, edx
		ret
	.elseif(bpp_==8)
		add		eax, edx	;offs + x*y
		ret
	.elseif(bpp_==16)
		shl		eax, 1
		add		eax, edx
		ret
	.elseif(bpp_==24)		;offs +3*x*y
		mov		ecx, edx
		mov		edx, 3
		mul		edx
		add		eax, ecx
		ret
	.elseif(bpp_==32)		;offs +4*x*y
		mov		ecx, edx
		mov		edx, 4
		mul		edx
		add		eax, ecx
		ret
	.endif
	ret
calc_pref_size	endp


draw_8	proc uses edi memDC:dword
	LOCAL	x:dword
	LOCAL	y:dword
	LOCAL	x_true:dword
	LOCAL	y_true:dword
	
		mov		edi, offset gradient
		mov		ecx, im_height
@yloop:
		push	ecx
		mov		y, ecx
		mov		ecx, im_width
@xloop:
		push	ecx
		mov		x, ecx
;------------------------------
.if(fInvertHoriz==0)		
		mov		eax, im_width
		sub		eax, x
		mov		x_true, eax
.else
		mov		eax, x
		dec		eax
		mov		x_true, eax
.endif
;------------------------------

.if(fInvertVert==0)		
		mov		eax, im_height
		sub		eax, y
		mov		y_true, eax
.else
		mov		eax, y
		dec		eax
		mov		y_true, eax
.endif

		;0x00bbggrr
		xor		eax, eax
		mov		al, [esi]	;8bit -> grayscale
		shl		eax, 2
		add		eax, edi	;offs+base
		mov		eax, [eax]	;Color Value
		
		invoke	SetPixel, memDC, x_true, y_true, eax
		inc		esi
		pop		ecx
		dec		ecx
		jnz		@xloop
		pop		ecx
		dec		ecx
		jnz		@yloop
	ret
draw_8 endp

draw_24	proc	uses edi memDC:dword
	LOCAL	x:dword
	LOCAL	y:dword
	LOCAL	x_true:dword
	LOCAL	y_true:dword
	LOCAL	v1:dword
	LOCAL	v2:dword
	LOCAL	v3:dword
	LOCAL	v4:dword
	LOCAL	unm_r:dword
	LOCAL	unm_g:dword
	LOCAL	unm_b:dword
	LOCAL	comp:dword
	
		mov		edi, offset gradient
		mov		ecx, im_height
@yloop:
		push	ecx
		mov		y, ecx
		mov		ecx, im_width
@xloop:
		push	ecx
		mov		x, ecx
		
;------------------------------
.if(fInvertHoriz==0)		
		mov		eax, im_width
		sub		eax, x
		mov		x_true, eax
.else
		mov		eax, x
		dec		eax
		mov		x_true, eax
.endif
;------------------------------

.if(fInvertVert==0)		
		mov		eax, im_height
		sub		eax, y
		mov		y_true, eax
.else
		mov		eax, y
		dec		eax
		mov		y_true, eax
.endif
		;------------------------------
		;Color Operations
		;0x00bbggrr
.if(fConvert24==0)
		.if(mask_on==0)
			xor		eax, eax
			mov		al, [esi+2]	;red component
			mov		ah, [esi+1]	;green component
			xor		ecx, ecx
			mov		cl, [esi+0]
			shl		ecx, 16
			or		eax, ecx
		.else
			;0, 1, 2
			xor		ecx, ecx
			
			xor		eax, eax
			mov		al, [esi+0]
			shl		eax, 16
			or		ecx, eax
			
			xor		eax, eax
			mov		al, [esi+1]
			shl		eax, 8
			or		ecx, eax
			
			xor		eax, eax
			mov		al, [esi+2]
			or		ecx, eax
			mov		comp, ecx
			
			invoke	GetUnmaskComp, comp, mask_r
			mov		unm_r, eax
			invoke	GetUnmaskComp, comp, mask_g
			mov		unm_g, eax
			invoke	GetUnmaskComp, comp, mask_b
			mov		unm_b, eax
			
			xor		ecx, ecx
			xor		eax, eax
			mov		al, byte ptr unm_r	;red component
			mov		ah, byte ptr unm_g	;green component
			xor		ecx, ecx
			mov		cl, byte ptr unm_b
			shl		ecx, 16
			or		eax, ecx
			
		.endif		
.else
		;Convert RGB->GrayScale
		;Brightness=0.3*Red + 0.59*Green + 0.11*Blue
		movzx	eax, byte ptr [esi+0]
		mov		v1, eax					;red
		movzx	ecx, byte ptr [esi+1]
		mov		v2, ecx					;green
		movzx	eax, byte ptr [esi+2]
		mov		v3, eax					;blue
		
		fild	v1
		fmul	C1			;C1*red
		
		fild	v2
		fmul	C2			;C2*green
		faddp   st(1), st
		
		fild	v3
		fmul	C3
		faddp   st(1), st
		
		fistp	v4
		mov		eax, v4
		
		shl		eax, 2
		add		eax, edi
		mov		eax, [eax]
		
.endif
		invoke	SetPixel, memDC, x_true, y_true, eax
		
		add		esi, 3		;next 3 bytes
		pop		ecx
		dec		ecx
		jnz		@xloop
		pop		ecx
		dec		ecx
		jnz		@yloop	
	ret
draw_24 endp

GrabImage	proc	hW:dword, saveFile:dword
	LOCAL	hSnapshot:HBITMAP
	LOCAL	client:RECT
	LOCAL	uiBytesPerRow:dword
	LOCAL	uiRemainderForPadding:dword
	LOCAL	uiBytesPerAllRows:dword
	LOCAL	pDataBits:dword
	LOCAL	bmi:BITMAPINFOHEADER;
	LOCAL	bmf:BITMAPFILEHEADER;
	LOCAL	hDC:dword
	LOCAL	hsave:dword
	LOCAL	temp:dword
	
	;db 0cch
	invoke	MakeClientSnapshot, addr client
	.if(eax!=0)
		mov		hSnapshot, eax
		mov		eax, client.right
		mov		edx, 3
		mul		edx
		mov		uiBytesPerRow, eax
		
		mov		eax, uiBytesPerRow
		cdq
		mov		ecx, 4
		idiv	ecx
		mov		uiRemainderForPadding, edx
		.if(uiRemainderForPadding>0)
			mov		eax, uiBytesPerRow
			mov		ecx, 4
			mov		edx, uiRemainderForPadding
			sub		ecx, edx
			add		eax, ecx
			mov		uiBytesPerRow, eax
		.endif
		
		mov		eax, uiBytesPerRow
		mov		ecx, client.bottom
		mul		ecx
		mov		uiBytesPerAllRows, eax	
		invoke	VirtualAlloc,0,uiBytesPerAllRows,MEM_COMMIT + MEM_RESERVE,PAGE_READWRITE
		mov		pDataBits, eax
		.if(eax!=0)
			invoke	ZeroMem,addr bmi, sizeof(BITMAPINFOHEADER)
			invoke	ZeroMem,addr bmf, sizeof(BITMAPFILEHEADER)
			
			invoke	GetDC, hView
			mov		hDC, eax
			
			mov		bmi.biSize, sizeof(BITMAPINFOHEADER)
			mov		bmi.biPlanes, 1
			mov		bmi.biBitCount, 24
			mov		eax, client.bottom
			mov		bmi.biHeight, eax
			mov		eax, client.right
			mov		bmi.biWidth, eax
			
			invoke	GetDIBits,hDC,hSnapshot,0,client.bottom,pDataBits,addr bmi,DIB_RGB_COLORS
			invoke	ReleaseDC,hView, hDC
			
			;Fill the file header
			mov		bmf.bfOffBits, sizeof(BITMAPINFOHEADER) + sizeof(BITMAPFILEHEADER)
			mov		eax, bmf.bfOffBits
			mov		ecx, uiBytesPerAllRows
			add		eax, ecx
			mov		bmf.bfType, 04D42h
			
			;Save file dialogue
			invoke	GetSaveFileName, ADDR ofn		

			invoke	CreateFile,saveFile,GENERIC_WRITE,FILE_SHARE_WRITE,0,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,0
			mov		hsave, eax
			invoke	WriteFile,hsave,addr bmf,sizeof(BITMAPFILEHEADER),addr temp,0
			invoke	WriteFile,hsave,addr bmi,sizeof(BITMAPINFOHEADER),addr temp,0
			invoke	WriteFile,hsave,pDataBits,uiBytesPerAllRows,addr temp,0
			invoke	CloseHandle,hsave
			
			invoke	VirtualFree,pDataBits,uiBytesPerAllRows,MEM_DECOMMIT + MEM_RELEASE
		.endif
		
	.endif
	ret
GrabImage	endp

MakeClientSnapshot proc client:dword
	LOCAL	hDC:dword
	LOCAL	rcClient:RECT
	LOCAL	bOk:dword
	LOCAL	hImage:dword
	LOCAL	hMemDC:HDC
	LOCAL	hDCBmp:HBITMAP
		
	mov		bOk,0
	mov		hImage, 0
	
	invoke	GetDC, hView
	mov		hDC, eax
	invoke	GetClientRect, hView, addr rcClient
	invoke	MemCopy, addr rcClient, client, sizeof(RECT);	client=rcClient

	invoke	CreateCompatibleBitmap, hDC, rcClient.right, rcClient.bottom
	mov		hImage, eax
	.if(eax!=0)
		invoke	CreateCompatibleDC, hDC
		mov		hMemDC, eax
		.if(eax!=0)
			invoke	SelectObject,hMemDC,hImage
			mov		hDCBmp, eax
			invoke	BitBlt,hMemDC,0,0,rcClient.right,rcClient.bottom,hDC,0,0,SRCCOPY
			invoke	SelectObject,hMemDC, hDCBmp
			invoke	DeleteDC, hMemDC
			mov		bOk, 1
		.endif
	.else
		invoke	ReleaseDC, hView, hDC
	.endif

	.if(bOk==0)
		.if(hImage!=0)
			invoke	DeleteObject, hImage
			mov		hImage, 0
		.endif
	.endif
	mov		eax, hImage
	ret
MakeClientSnapshot	endp

MemCopy proc public uses esi edi ecx Source:dword,Dest:dword,ln:DWORD
    cld
    mov esi, [Source]
    mov edi, [Dest]
    mov ecx, [ln]

    shr ecx, 2
    rep movsd

    mov ecx, [ln]
    and ecx, 3
    rep movsb
    ret
MemCopy endp

ZeroMem	proc	uses esi mem:dword, size_:dword
	mov		esi, mem
	mov		ecx, size_
	xor		eax, eax
@@:
	mov		[esi], al
	inc		esi
	dec		ecx
	jnz		@B
	ret
ZeroMem endp

generate_gradient proc uses esi
	mov		esi, offset gradient
	xor		eax, eax
	mov		ecx, 256
@@:
	mov		[esi], eax
	add		esi, 4
	add		eax, 010101h
	dec		ecx
	jnz		@B
	ret
generate_gradient endp

draw_16	proc uses edi memDC:dword
	LOCAL	x:dword
	LOCAL	y:dword
	LOCAL	x_true:dword
	LOCAL	y_true:dword
	LOCAL	v1:dword
	LOCAL	v2:dword
	LOCAL	v3:dword
	LOCAL	v4:dword
	
	LOCAL	comp:dword
	LOCAL	unm_r:dword
	LOCAL	unm_g:dword
	LOCAL	unm_b:dword
	
		mov		edi, offset gradient
		mov		ecx, im_height
@yloop:
		push	ecx
		mov		y, ecx
		mov		ecx, im_width
@xloop:
		push	ecx
		mov		x, ecx
;------------------------------
.if(fInvertHoriz==0)		
		mov		eax, im_width
		sub		eax, x
		mov		x_true, eax
.else
		mov		eax, x
		dec		eax
		mov		x_true, eax
.endif
;------------------------------
.if(fInvertVert==0)		
		mov		eax, im_height
		sub		eax, y
		mov		y_true, eax
.else
		mov		eax, y
		dec		eax
		mov		y_true, eax
.endif

.if(fConvert24==0)
		.if(mask_on==0)
			;0x00bbggrr
			xor		eax, eax

			xor		edx, edx	;RED
			mov		dx, [esi]
			and		dx, 0F800h
			shr		edx, 8
			or		eax, edx
;------------------------------------
			xor		edx, edx	;GREEN
			mov		dx, [esi]
			and		dx, 07E0h
			shl		edx, 5
			or		eax, edx
;------------------------------------
			xor		edx, edx	;BLUE
			mov		dx, [esi]
			and		dx, 0001Fh
			shl		edx, 19
			or		eax, edx
;------------------------------------
		.else
			xor		edx, edx	;RED
			mov		dx, [esi]
			mov		comp, edx
						
			invoke	GetUnmaskComp, comp, mask_r
			mov		unm_r, eax
			invoke	GetUnmaskComp, comp, mask_g
			mov		unm_g, eax
			invoke	GetUnmaskComp, comp, mask_b
			mov		unm_b, eax
			
			xor		ecx, ecx
			xor		eax, eax
			mov		al, byte ptr unm_r	;red component
			mov		ah, byte ptr unm_g	;green component
			xor		ecx, ecx
			mov		cl, byte ptr unm_b
			shl		ecx, 16
			or		eax, ecx
		
		.endif
.else		
		xor		edx, edx	;RED
		mov		dx, [esi]
		and		dx, 0F800h
		shr		edx, 8
		mov		v1, edx

		xor		edx, edx	;GREEN
		mov		dx, [esi]
		and		dx, 07E0h
		shr		edx, 3
		mov		v2, edx
		
		xor		edx, edx	;BLUE
		mov		dx, [esi]
		and		dx, 0001Fh
		shl		edx, 3
		mov		v3, edx

		fild	v1
		fmul	C1			;C1*red
		
		fild	v2
		fmul	C2			;C2*green
		faddp   st(1), st
		
		fild	v3
		fmul	C3			;C3*blue
		faddp   st(1), st
		
		fistp	v4
		mov		eax, v4
		
		shl		eax, 2
		add		eax, edi
		mov		eax, [eax]
.endif

		invoke	SetPixel, memDC, x_true, y_true, eax
		add		esi, 2		;next pixel - 2 byte
		pop		ecx
		dec		ecx
		jnz		@xloop
		pop		ecx
		dec		ecx
		jnz		@yloop
	ret
draw_16 endp

draw_1	proc uses edi memDC:dword
	LOCAL	x:dword
	LOCAL	y:dword
	LOCAL	x_true:dword
	LOCAL	y_true:dword
	LOCAL	xt:dword
	LOCAL	yt:dword
	
		mov		ecx, im_height
@yloop:
		push	ecx
		mov		y, ecx
		mov		ecx, im_width
@xloop:
		push	ecx
		mov		x, ecx
;------------------------------
.if(fInvertHoriz==0)		
		mov		eax, im_width
		sub		eax, x
		mov		x_true, eax
.else
		mov		eax, x
		dec		eax
		mov		x_true, eax
.endif
;------------------------------
.if(fInvertVert==0)		
		mov		eax, im_height
		sub		eax, y
		mov		y_true, eax
.else
		mov		eax, y
		dec		eax
		mov		y_true, eax
.endif

		invoke	getPixel_1, x_true, y_true
		mov		ecx, x
		mov		edx, y
		dec		ecx
		dec		edx
		mov		xt, ecx
		mov		yt, edx
		invoke	SetPixel, memDC, xt, yt, eax
		pop		ecx
		dec		ecx
		jnz		@xloop
		pop		ecx
		dec		ecx
		jnz		@yloop
	ret
draw_1 endp

getPixel_1	proc x:dword, y:dword
	
	mov		edx, y
	mov		eax, im_width
	mul		edx				;eax = y * im_width
	shr		eax, 3			;eax / 8
	
	mov		edx, x
	shr		edx, 3			;edx = x / 8
	add		eax, edx		
	
	mov		edx, pData
	add		edx, eax
	
	mov		al, [edx]		;Target byte
	
	mov		edx, x
	and		edx, 7			;Test mask index 0..7
	mov		dl, masktable[edx]
	
	and		al, dl
	test	al, al
	mov		ecx, 0		;Black
	mov		edx, 0FFFFFFh;White
	cmovz	eax, ecx
	cmovnz	eax, edx
	
	ret
getPixel_1 endp

draw_2	proc uses edi memDC:dword
	LOCAL	x:dword
	LOCAL	y:dword
	LOCAL	x_true:dword
	LOCAL	y_true:dword
	LOCAL	xt:dword
	LOCAL	yt:dword
	
		mov		edi, offset gradient
		mov		ecx, im_height
@yloop:
		push	ecx
		mov		y, ecx
		mov		ecx, im_width
@xloop:
		push	ecx
		mov		x, ecx
;------------------------------
.if(fInvertHoriz==0)		
		mov		eax, im_width
		sub		eax, x
		mov		x_true, eax
.else
		mov		eax, x
		dec		eax
		mov		x_true, eax
.endif
;------------------------------
.if(fInvertVert==0)		
		mov		eax, im_height
		sub		eax, y
		mov		y_true, eax
.else
		mov		eax, y
		dec		eax
		mov		y_true, eax
.endif

		invoke	getPixel_2, x_true, y_true
		
		mov		ecx, x
		mov		edx, y
		dec		ecx
		dec		edx
		mov		xt, ecx
		mov		yt, edx
		invoke	SetPixel, memDC, xt, yt, eax
		pop		ecx
		dec		ecx
		jnz		@xloop
		pop		ecx
		dec		ecx
		jnz		@yloop
	ret
draw_2 endp

getPixel_2	proc x:dword, y:dword
	mov		edx, y
	mov		eax, im_width
	mul		edx				;eax = y * im_width
	shr		eax, 2			;eax / 4
	
	mov		edx, x
	shr		edx, 2			;edx = x / 4
	add		eax, edx		
	
	mov		edx, pData
	add		edx, eax
	
	xor		eax, eax
	mov		al, [edx]		;Target byte
	
	mov		edx, x
	and		edx, 3
	mov		dl, masktable2[edx];mask
	
	and		al, dl
	.if(dl==011000000b)
		shr al, 6
	.elseif(dl==000110000b)
		shr al, 4
	.elseif(dl==000001100b)
		shr al, 2
	.endif
	
	;get gradient color	
	shl		eax, 8
	add		eax, edi	;offs+base
	mov		eax, [eax]	;Color Value
	ret
getPixel_2 endp

draw_4	proc uses edi memDC:dword
	LOCAL	x:dword
	LOCAL	y:dword
	LOCAL	x_true:dword
	LOCAL	y_true:dword
	LOCAL	xt:dword
	LOCAL	yt:dword
	
		mov		edi, offset gradient
		mov		ecx, im_height
@yloop:
		push	ecx
		mov		y, ecx
		mov		ecx, im_width
@xloop:
		push	ecx
		mov		x, ecx
;------------------------------
.if(fInvertHoriz==0)		
		mov		eax, im_width
		sub		eax, x
		mov		x_true, eax
.else
		mov		eax, x
		dec		eax
		mov		x_true, eax
.endif
;------------------------------
.if(fInvertVert==0)		
		mov		eax, im_height
		sub		eax, y
		mov		y_true, eax
.else
		mov		eax, y
		dec		eax
		mov		y_true, eax
.endif

		invoke	getPixel_4, x_true, y_true
		
		mov		ecx, x
		mov		edx, y
		dec		ecx
		dec		edx
		mov		xt, ecx
		mov		yt, edx
		invoke	SetPixel, memDC, xt, yt, eax
		pop		ecx
		dec		ecx
		jnz		@xloop
		pop		ecx
		dec		ecx
		jnz		@yloop
	ret
draw_4 endp

getPixel_4	proc x:dword, y:dword
	mov		edx, y
	mov		eax, im_width
	mul		edx				;eax = y * im_width
	shr		eax, 1			;eax / 2
	
	mov		edx, x
	shr		edx, 1			;edx = x / 2
	add		eax, edx		
	
	mov		edx, pData
	add		edx, eax
	
	xor		eax, eax
	mov		al, [edx]		;Target byte
	
	mov		edx, x
	and		edx, 1
	mov		dl, masktable3[edx];mask
	
	and		al, dl
	.if(dl==011110000b)
		shr al, 4
	.endif
	
	shl		eax, 6
	;get gradient color
	add		eax, edi	;offs+base
	mov		eax, [eax]	;Color Value	
	ret
getPixel_4 endp

getStep	proc	hw:dword
	LOCAL	bpp_:dword
	
	invoke	getBPP, hw
	mov		bpp_, eax
	
	mov		ecx, im_width
	mov		eax, im_height
	mul		ecx				;x*y
	mov		edx, 0
	.if(bpp_==1)
		shr		eax, 3
		add		eax, edx
		ret
	.elseif(bpp_==2)
		shr		eax, 2
		add		eax, edx
		ret
	.elseif(bpp_==4)
		shr		eax, 1
		add		eax, edx
		ret
	.elseif(bpp_==8)
		add		eax, edx	;x*y
		ret
	.elseif(bpp_==16)
		shl		eax, 1
		add		eax, edx
		ret
	.elseif(bpp_==24)		;3*x*y
		mov		ecx, edx
		mov		edx, 3
		mul		edx
		add		eax, ecx
		ret
	.endif

	ret
getStep endp

draw_32	proc	uses edi memDC:dword
	LOCAL	x:dword
	LOCAL	y:dword
	LOCAL	x_true:dword
	LOCAL	y_true:dword
	LOCAL	v1:dword
	LOCAL	v2:dword
	LOCAL	v3:dword
	LOCAL	v4:dword
	LOCAL	comp:dword
	LOCAL	unm_r:dword
	LOCAL	unm_g:dword
	LOCAL	unm_b:dword
	
		mov		edi, offset gradient
		mov		ecx, im_height
@yloop:
		push	ecx
		mov		y, ecx
		mov		ecx, im_width
@xloop:
		push	ecx
		mov		x, ecx
		
;------------------------------
.if(fInvertHoriz==0)		
		mov		eax, im_width
		sub		eax, x
		mov		x_true, eax
.else
		mov		eax, x
		dec		eax
		mov		x_true, eax
.endif
;------------------------------

.if(fInvertVert==0)		
		mov		eax, im_height
		sub		eax, y
		mov		y_true, eax
.else
		mov		eax, y
		dec		eax
		mov		y_true, eax
.endif
		;------------------------------
		;Color Operations
		;0x00bbggrr
.if(fConvert24==0)
		.if(mask_on==0)
			xor		eax, eax
			mov		al, [esi+2]	;red component
			mov		ah, [esi+1]	;green component
			xor		ecx, ecx
			mov		cl, [esi+0]
			shl		ecx, 16
			or		eax, ecx
		.else
			;0, 1, 2, 3
			xor		ecx, ecx
			
			xor		eax, eax
			mov		al, [esi+0]
			shl		eax, 24
			or		ecx, eax
			
			xor		eax, eax
			mov		al, [esi+1]
			shl		eax, 16
			or		ecx, eax
			
			xor		eax, eax
			mov		al, [esi+2]
			shl		eax, 8
			or		ecx, eax
			
			xor		eax, eax
			mov		al, [esi+3]
			or		ecx, eax
			mov		comp, ecx
			
			
			invoke	GetUnmaskComp, comp, mask_r
			mov		unm_r, eax
			invoke	GetUnmaskComp, comp, mask_g
			mov		unm_g, eax
			invoke	GetUnmaskComp, comp, mask_b
			mov		unm_b, eax
			
			xor		ecx, ecx
			xor		eax, eax
			mov		al, byte ptr unm_r	;red component
			mov		ah, byte ptr unm_g	;green component
			xor		ecx, ecx
			mov		cl, byte ptr unm_b
			shl		ecx, 16
			or		eax, ecx		
		.endif		
.else
		;Convert RGB->GrayScale
		;Brightness=0.3*Red + 0.59*Green + 0.11*Blue
		movzx	eax, byte ptr [esi]
		mov		v1, eax					;red
		movzx	ecx, byte ptr [esi+1]
		mov		v2, ecx					;green
		movzx	eax, byte ptr [esi+2]
		mov		v3, eax					;blue
		
		fild	v1
		fmul	C1			;C1*red
		
		fild	v2
		fmul	C2			;C2*green
		faddp   st(1), st
		
		fild	v3
		fmul	C3
		faddp   st(1), st
		
		fistp	v4
		mov		eax, v4
		
		shl		eax, 2
		add		eax, edi
		mov		eax, [eax]
		
.endif
		invoke	SetPixel, memDC, x_true, y_true, eax
		
		add		esi, 4		;next 4 bytes
		pop		ecx
		dec		ecx
		jnz		@xloop
		pop		ecx
		dec		ecx
		jnz		@yloop	
	ret
draw_32 endp

GetUnmaskComp proc src:dword, mask_:dword
	LOCAL	bit:dword
	
	;Search left bit
	mov		ecx, 32
	mov		edx, 080000000h	;search mask
@@:
	mov		eax, mask_	
	and		eax, edx
	jnz		@F
	shr		edx, 1
	dec		ecx
	jnz		@B
@@:
	mov		bit, ecx	;left bit number

	;if (bit-8) > 0 -> shift right on (bit-8)
	;else -> shift left on (8-bit)
	mov		eax, src
	and		eax, mask_
	
	.if(ecx>8)
		mov	ecx, bit
		sub	ecx, 8
		
		shr eax, cl
	.else
		mov	ecx, 8
		sub ecx, bit
		shl	eax, cl
	.endif
	
	ret
GetUnmaskComp endp

GetMaskParams proc hWnd:dword
	LOCAL	sb[32]:byte
	LOCAL	res:dword
	
	invoke IsDlgButtonChecked, hWnd, IDC_MASK
	.if eax == BST_CHECKED
		mov		mask_on, 1
	.else
		mov		mask_on, 0
	.endif

	;R
	mov		res, 0
	invoke	GetDlgItemText, hWnd, R_32, addr sb, 32
	invoke	htodw, addr sb
	and		eax, 0FFh
	shl		eax, 24
	or		res, eax

	invoke	GetDlgItemText, hWnd, R_24, addr sb, 32
	invoke	htodw, addr sb
	and		eax, 0FFh
	shl		eax, 16
	or		res, eax

	invoke	GetDlgItemText, hWnd, R_16, addr sb, 32
	invoke	htodw, addr sb
	and		eax, 0FFh
	shl		eax, 8
	or		res, eax
	
	invoke	GetDlgItemText, hWnd, R_8, addr sb, 32
	invoke	htodw, addr sb
	and		eax, 0FFh
	or		res, eax
	mov		eax, res
	mov		mask_r, eax
	
	;G
	mov		res, 0
	invoke	GetDlgItemText, hWnd, G_32, addr sb, 32
	invoke	htodw, addr sb
	and		eax, 0FFh
	shl		eax, 24
	or		res, eax

	invoke	GetDlgItemText, hWnd, G_24, addr sb, 32
	invoke	htodw, addr sb
	and		eax, 0FFh
	shl		eax, 16
	or		res, eax

	invoke	GetDlgItemText, hWnd, G_16, addr sb, 32
	invoke	htodw, addr sb
	and		eax, 0FFh
	shl		eax, 8
	or		res, eax
	
	invoke	GetDlgItemText, hWnd, G_8, addr sb, 32
	invoke	htodw, addr sb
	and		eax, 0FFh
	or		res, eax
	mov		eax, res
	mov		mask_g, eax

	;B
	mov		res, 0
	invoke	GetDlgItemText, hWnd, B_32, addr sb, 32
	invoke	htodw, addr sb
	and		eax, 0FFh
	shl		eax, 24
	or		res, eax

	invoke	GetDlgItemText, hWnd, B_24, addr sb, 32
	invoke	htodw, addr sb
	and		eax, 0FFh
	shl		eax, 16
	or		res, eax

	invoke	GetDlgItemText, hWnd, B_16, addr sb, 32
	invoke	htodw, addr sb
	and		eax, 0FFh
	shl		eax, 8
	or		res, eax
	
	invoke	GetDlgItemText, hWnd, B_8, addr sb, 32
	invoke	htodw, addr sb
	and		eax, 0FFh
	or		res, eax
	mov		eax, res
	mov		mask_b, eax

	ret
GetMaskParams endp

htodw proc String:DWORD

  ; -----------------------------------
  ; Convert hex string into dword value
  ; Return value in eax
  ; -----------------------------------

    push ebx
    push esi
    push edi

    mov edi, String
    mov esi, String 

     ALIGN 4

  again:  
    mov al,[edi]
    inc edi
    or  al,al
    jnz again
    sub esi,edi
    xor ebx,ebx
    add edi,esi
    xor edx,edx
    not esi             ;esi = lenth

  .while esi != 0
    mov al, [edi]
    cmp al,'A'
    jb figure
    sub al,'a'-10
    adc dl,0
    shl dl,5            ;if cf set we get it bl 20h else - 0
    add al,dl
    jmp next
  figure: 
    sub al,'0'
  next:  
    lea ecx,[esi-1]
    and eax, 0Fh
    shl ecx,2           ;mul ecx by log 16(2)
    shl eax,cl          ;eax * 2^ecx
    add ebx, eax
    inc edi
    dec esi
  .endw

    mov eax,ebx

    pop edi
    pop esi
    pop ebx

    ret

htodw endp

InitMaskTable	proc hWnd:dword
	invoke	SetDlgItemText, hWnd, R_32, addr sz_zero
	invoke	SetDlgItemText, hWnd, R_24, addr sz_zero
	invoke	SetDlgItemText, hWnd, R_16, addr sz_zero
	invoke	SetDlgItemText, hWnd, R_8, addr sz_zero

	invoke	SetDlgItemText, hWnd, G_32, addr sz_zero
	invoke	SetDlgItemText, hWnd, G_24, addr sz_zero
	invoke	SetDlgItemText, hWnd, G_16, addr sz_zero
	invoke	SetDlgItemText, hWnd, G_8, addr sz_zero

	invoke	SetDlgItemText, hWnd, B_32, addr sz_zero
	invoke	SetDlgItemText, hWnd, B_24, addr sz_zero
	invoke	SetDlgItemText, hWnd, B_16, addr sz_zero
	invoke	SetDlgItemText, hWnd, B_8, addr sz_zero

	ret
InitMaskTable endp

end start
